import type { GomokuContext } from './GomokuContext';
import { GomokuCountMap } from './GomokuCountMap';
import type { IGomokuBoard, IGomokuCandidateState, IGomokuPiece, IScoreMap } from './types';
export declare class GomokuState {
    protected readonly context: GomokuContext;
    protected readonly countMap: GomokuCountMap;
    protected readonly candidateSet: Set<number>;
    protected readonly board: IGomokuBoard;
    protected placedCount: number;
    constructor(context: GomokuContext, scoreMap: IScoreMap);
    init(pieces?: ReadonlyArray<IGomokuPiece>): void;
    forward(id: number, player: number): void;
    rollback(id: number): void;
    expand(currentPlayer: number, scoreForPlayer: number): IGomokuCandidateState[];
    score(currentPlayer: number, scoreForPlayer: number): number;
    isFinal(): boolean;
    randomMove(): number | -1;
    protected hasPlacedNeighbors(id: number): boolean;
    protected beforeForward(id: number): void;
    protected afterForward(id: number): void;
    protected beforeRollback(id: number): void;
    protected afterRollback(id: number, player: number): void;
}
